Versionsverlauf
===============

## [Noch nicht veröffentlicht]

- derzeit keine Änderungen

## [Version 3.1.0] - 2020-06-05

- bei Anfragen wurden Anmeldungen auf Parameteränderungen, die für zyklische Prognosen erforderlich 
  sind nicht korrekt entfernt, womit die Liste der Anmeldungen nach einer entsprechenden Laufzeit
  den verfügbaren Speicher überschritten hat (ISSUE-#7)
- mit dem Startparameter "-compressTime=23:00" kann der Zeitpunkt der täglichen Komprimierung
  der Derby-Gangliniendatenbank angegeben werden. Standard ist, wie angegeben, 23 Uhr. (ISSUE-#8)

## [Version 3.0.3] - 2019-09-11

- bei geordnetem Herunterfahren wird ein Shutdown auf der Datenbank ausgeführt,
  was den nächsten Start beschleunigt

## [Version 3.0.2] - 2019-06-10

- alte Stützstellen wurden nicht korrekt bereinigt, so dass die Datenbank
  unnötig groß wird
- Leseoperationen werden während des Kompressions-Vorgangs der Datenbank
  weiter beantwortet  

## [Version 3.0.1] - 2019-04-08

-Korrektur Abhängigkeit von de.bsvrz.iav:de.bsvrz.iav.gllib:4.0.0' (war vorher 4.0.0-SNAPSHOT)

## [Version 3.0.0]

### Allgemeine Hinweise

Die Ganglinienprognose wurde für die neue Ganglinien-Bibliothek (Version 4) angepasst.

Insbesondere wurden folgende Änderungen vorgenommen:

- Der Zugriff auf die Ganglinien-Datenbank erfolgt nicht mehr über eine Server-Instanz.
  Stattdessen wird die Ganglinien-Datenbank als eingebettete Datenbank von der 
  Ganglinienprognose verwaltet. Die Startoptionen für die Datenbankverbindung können 
  daher entfallen, lediglich das Verzeichnis, in dem die Datenbank abgelegt wird,
  muss angegeben werden.
- Die Datenbank speichert keine Blobs für jeden MQ mehr, sondern einzelne Ganglinien
  mit einzelnen Stützstellen.
- Die optionale Konvertierung einer "alten" Datenbank erfolgt automatisch. Da das eine
  gewisse Zeit dauern kann, ist es auch möglich das eingebettete Tool
  "de.bsvrz.iav.glprog.glprog.update.GanglinienDbUpdater" als Standard-Datenverteiler-
  Applikation auszuführen. Das Verzeichnis mit der Datenbank wird über den Startparameter
  "-dbVerzeichnis={verzeichnis}" angegeben.
- die Abhängigkeit zur Funktionsbibliothek "de.bsvrz.sys.funclib.bitctrl" wurde eliminiert.

### Bugfixes aus vorherigen Versionen

- die gleichzeitige Bearbeitung einer Ganglininen-Prognose-Anfrage in mehreren Threads wird verhindert
- eine Betriebsmeldung wird versendet, wenn für die Prognose die Verwendung von Referenzganglinien gefordert wurde, aber keine einzige Referenzganglinie ermittelt werden konnte
- bei der Bearbeitung von Anfragen mit dem Parameter "nurLangfristigePrognose" werden unnötige Archivanfragen unterdrückt

## [Version 2.4.1]

- NERZ: Umstellung auf Gradle, Build durch FTB und Bereitstellung auf NERZ-Repositories
- **Anpassungen für den Sommerzeitwechsel**
  Bei einer Abfrage über den Sommerzeitwechsel werden für den Tag mit 23 Stunden alle Stützstellen
  der gelernten Ganglinien zwischen 2 und 3 Uhr entfernt und die Stützstellen nach 3 Uhr eine
  Stunde nach vorn verschoben. Für den Tag mit 25 Stunden werden alle Stützstellen ab 2 Uhr um
  eine Stunde nach hinten verschoben.

## Version 2.4.0

- Umstellung auf Java 8 und UTF-8

## Version 2.3.0

- Umstellung auf Maven-Build

## Version 2.2.3

- Bugfix für Mantis #4033: Bei der Auswahl von Ganglinien in einer Anfrage,
  die aus mehreren Teilintervallen besteht, konnte es unter Umständen dazu
  kommen, das bei der Auswahl der Ereignisganglinien sich die Teilintervalle
  gegenseitig beeinflusst haben. 

## Version 2.2.2

- Bugfix für Mantis #4034: Die Ganglinienprognose beendet sich unter
  bestimmten Umständen direkt nach dem Start, wenn beim Starten eine Anfrage
  eintrifft.
- Mantis #4033: Beim Pattern Matching kommt es unter unbekannten Umständen
  zu einer IllegalArgumentException, weil die Liste der zu vergleichenden
  Ganglinien leer ist. Um das Problem weiter untersuchen zu können, wurden
  zusätzliche Logmeldungen und Fehlerprüfungen eingebaut.

## Version 2.2.1

- Mantis #2363: Verbesserung für verwaltete Betriebsmeldungen
  Die Applikationskennung wird beim Start überschrieben mit
  {Main-Klasse}_{Applikations-ID}, damit sie nicht mehr zu lang wird.

## Version 2.2.0

- Bearbeitung der Anfragen überarbeitet, so das weniger Arbeitsspeicher
  gebraucht wird. Es werden nur noch eine begrenzte Anzahl von Anfragen
  gleichzeitig bearbeitet und alle andern in eine Warteschlange gelegt und
  nacheinander abarbeitet. (Mantis #2103, #2104, #2105)
- Loggausgaben beim Unit-Test werden wieder angezeigt.
- Überarbeitung der JUnit-Tests damit sie nach DAF-Upgrade wieder wie gewohnt
  funktionieren.

## Version 2.1.0

- Betriebsmeldungen um Systemobjekt in ID ergänzen, wenn sinnvoll.
  (Mantis #2088)
- Quelltext kompatibler mit Java 6 gemacht.

## Version 2.0.0

- Umstellung der Ganglinienspeicherung von der Behandlung als Parameter (atg.ganglinie)
  auf eine separate Speicherung in einer Derby DB.

## Version 1.3.0

- Betriebsinformation und Prüfprozedur liegen jetzt im Zustand "akzeptiert"
  vor.
    
## Version 1.2.1

- Betriebsinformation aktualisiert.
- NEU: Debugausgaben, wenn nicht genug Daten für Prognose (Ganglinien,
  Kalender, Parameter).

## Version 1.2.0

- Prüfprozedur und Prüfprotokoll in Release aufgenommen
- Betriebsinformation in Release aufgenommen

## Version 1.1.0

- Anpassung an überarbeitetet Funktionsbibliothek de.bsvrz.sys.funclib.bitctrl

## Version 1.0.0

- Getestet Version.

## Version 0.9.0

- Anpassung wegen neuer Paketstruktur der Kernsoftware.
- Fast fertige aber noch nicht vollständig getestete Version.   

## Version 0.5.0

- Erste Auslieferung, Vorabversion

[Noch nicht veröffentlicht]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.iav.glprog/compare/v3.1.0...HEAD
[Version 3.1.0]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.iav.glprog/compare/v3.0.3...v3.1.0
[Version 3.0.3]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.iav.glprog/compare/v3.0.2...v3.0.3
[Version 3.0.2]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.iav.glprog/compare/v3.0.1...v3.0.2
[Version 3.0.1]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.iav.glprog/compare/v3.0.0...v3.0.1
[Version 3.0.0]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.iav.glprog/compare/v2.4.1...v3.0.0
[Version 2.4.1]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.iav.glprog/compare/v2.4.0...v2.4.1
